<bugID>337868<Summary>Implement result view for toolbar for dynamic updating</Summary><Description>The new HistoryResultView API allows the toolbar to be dynamically changed. Currently, the entire toolbar is rebuilt when anything on the toolbar changes, which can be really slow.

Bug 337855 is doing the same thing for the bookmarks menu.</Description></bugID>